<?php

/*
////////////////////////////////////////////////////////////////////////////////
// JohnCMS                             Content Management System              //
// Официальный сайт сайт проекта:      http://johncms.com                     //
// Дополнительный сайт поддержки:      http://gazenwagen.com                  //
////////////////////////////////////////////////////////////////////////////////
// JohnCMS core team:                                                         //
// Евгений Рябинин aka john77          john77@gazenwagen.com                  //
// Олег Касьянов aka AlkatraZ          alkatraz@gazenwagen.com                //
//                                                                            //
// Информацию о версиях смотрите в прилагаемом файле version.txt              //
////////////////////////////////////////////////////////////////////////////////
*/


defined('_IN_JOHNCMS') or die('Error: restricted access');

// Проверяем права доступа
if ($rights < 9) {
  header("Location: $home?err");
 exit;
}
$bot_d = mysql_fetch_assoc(mysql_query("select `name`, `tip` from `chat_bot` where id='" . $id . "'"));

/*
-----------------------------------------------------------------
Функция подсветки результатов запроса
-----------------------------------------------------------------
*/
function ReplaceKeywords($search, $text) {
  $search = str_replace('*', '', $search);
  return mb_strlen($search) < 4 ? $text : preg_replace('|('.preg_quote($search, '/').')|siu','<span style="background-color: #FFFF33">$1</span>',$text);
}
echo '<div class="phdr"><a href="menu.php?act=mod_phrases&amp;id='.$id.'"><b>Фразы</b></a> | <b>'.$bot_d['name'].':</b> Поиск фраз</div>';

/*
-----------------------------------------------------------------
Принимаем данные, выводим форму поиска
-----------------------------------------------------------------
*/
$search = isset ($_POST['search']) ? trim($_POST['search']) : '';
$search = $search ? $search : rawurldecode(trim($_GET['search']));
$search = preg_replace("/[^\w\x7F-\xFF\s]/", " ", $search);
$search_t = isset($_REQUEST['t']) && $bot_d['tip'] ? abs(intval($_REQUEST['t'])) : 0;
echo '<div class="gmenu"><form action="?act=mod_search&amp;id='.$id.'" method="post"><p>';
echo '<input type="text" value="' . ($search ? checkout($search) : '') . '" name="search" />';
echo '<input type="submit" value="Поиск" name="submit" />';
if ($bot_d['tip']) {
  echo '<p><b>Поиск</b><br />';
  echo '<input type="radio" value="0" name="t"'.(!$search_t ? ' checked="checked"' : '').'/>&#160;В фразах<br />';
  echo '<input type="radio" value="1" name="t"'.($search_t == 1 ? ' checked="checked"' : '').'/>&#160;В ответах<br />';
  echo '<input type="radio" value="2" name="t"'.($search_t == 2 ? ' checked="checked"' : '').'/>&#160;Везде</p>';
}
echo '</p></form></div>';

/*
-----------------------------------------------------------------
Проверям на ошибки
-----------------------------------------------------------------
*/
$error = false;
if ($search && mb_strlen($search) < 4)
  $error = 'Общая длина поискового запроса должна быть не менее 4 букв.';
if ($search && mb_strlen($search) > 64)
  $error = 'Общая длина поискового запроса должна быть не более 64 букв.';
if ($search && !$error) {
  
  /*
  -----------------------------------------------------------------
  Выводим результаты поиска
  -----------------------------------------------------------------
  */
  echo '<div class="bmenu">Результаты поиска</div>';
  switch ($search_t) {
    case 1:
      $sql = " (`otvet`) like ('%" . mysql_real_escape_string($search) . "%')";
    break;

    case 2:
      $sql = " ((`otvet`) like ('%" . mysql_real_escape_string($search) . "%') OR (`vopros`) like ('%" . mysql_real_escape_string($search) . "%'))";
    break;
    
    default :
      $sql = " (`vopros`) like ('%" . mysql_real_escape_string($search) . "%')";
  }
  $total = mysql_result(mysql_query("SELECT COUNT(*) FROM `chat_vop` WHERE".$sql." AND `id_bot` = '" .$id . "'"), 0);
  if (!empty($total)) {
    $req = mysql_query("SELECT * FROM `chat_vop` WHERE".$sql." AND `id_bot` = '" .$id . "' LIMIT $start, $kmess");
    while ($res = mysql_fetch_assoc($req)) {
      echo is_integer($i / 2) ? '<div class="list1">' : '<div class="list2">';
      echo '<b>'.($bot_d['tip'] ? 'Вопрос' : 'Фраза').':</b> '. (!$search_t ? ReplaceKeywords($search, $res['vopros']) : $res['vopros']);
      if ($res['otvet'])
        echo '<br /><b>Ответ:</b> '. ($search_t ? ReplaceKeywords($search, $res['otvet']) : $res['otvet']);
      echo '<div class="sub"><a href="?act=mod_phrases&amp;mod=red&amp;id=' . $res['id'] . '">Редактировать</a> - ';
      echo '<a href="?act=mod_phrases&amp;mod=dell&amp;id=' . $res['id'] . '">Удалить</a>';
      echo '</div></div>';
     ++$i;
    }
  } else {
    echo '<div class="rmenu"><p>По Вашему запросу ничего не найдено</p></div>';
  }
  echo '<div class="phdr">Всего совпадений: ' . $total . '</div>';
  // Постраничная навигация
  if ($total > $kmess) {
    echo '<p>' . pagenav('?act=mod_search&amp;id='.$id. '&amp;' . ($search_t ? 't='.$search_t.'&amp;' : '') . 'search=' . rawurlencode($search) . '&amp;', $start, $total, $kmess) . '</p>';
    echo '<p><form action="?act=mod_search&amp;id='.$id. '&amp;' . ($search_t ? 't='.$search_t.'&amp;' : '') . 'search=' . rawurlencode($search) . '" method="post">';
    echo '<input type="text" name="page" size="2"/><input type="submit" value="К странице &gt;&gt;"/></form></p>';
  }
} else {
  
  /*
  -----------------------------------------------------------------
  Выводим сообщение об ошибке
  -----------------------------------------------------------------
  */
  if ($error)
    echo '<small><div class="rmenu"><p><b>ОШИБКА!</b><br />' . $error . '</p></div></small>';
  // Инструкции для поиска
  echo '<div class="phdr"><small>Длина запроса: 4 мин., 64 макс.<br />Поиск нечувствителен к регистру букв<br />Результаты выводятся с сортировкой по релевантности</small></div>';
}
echo '<p>' . ($search ? '<a href="?act=mod_search&amp;mod=mod_search&amp;id='.$id.'">Новый поиск</a><br />' : '') . '<a href="?act=mod_phrases&amp;id='.$id.'">К фразам</a></p>';

?>